## slirp 1.0.14pre1

=== src/Makefile ===
# Generated automatically from Makefile.in by configure.

#
# Makefile for GNU Autoconf
#

version = 1.0.13
srcdir = .
COMMON_DEFS =  -I. -I${srcdir} -DUSE_PPP #-DDEBUG
CC = gcc
CPP = gcc -E $(COMMON_DEFS) -DUSE_PPP -g -O2
CFLAGS = $(COMMON_DEFS) -g -O2 -O2 -Wall -Wno-implicit -Wmissing-prototypes
PPPCFLAGS = $(COMMON_DEFS) -g -O2 -O2 
SHELL = /bin/sh
MKPRO = /usr/bin/perl ${srcdir}/mkpro
MAKEPRO = $(CPP) $< | $(MKPRO) > $@.bak && mv -f $@.bak $@

PPPOBJS = auth.o bsd-comp.o ccp.o chap.o fsm.o ipcp.o lcp.o magic.o md5.o pppdfncs.o upap.o ppp.o

PPPOBJ = $(PPPOBJS)

OBJ = $(PPPOBJ) cksum.o debug.o if.o ip_icmp.o ip_input.o ip_output.o main.o mbuf.o\
	misc.o options.o sbuf.o sl.o slcompress.o socket.o tcp_input.o\
	tcp_output.o tcp_subr.o tcp_timer.o terminal.o ttys.o udp.o 

PROTO = ${srcdir}/cksum.p ${srcdir}/debug.p ${srcdir}/if.p ${srcdir}/ip_icmp.p\
	${srcdir}/ip_input.p ${srcdir}/ip_output.p ${srcdir}/main.p ${srcdir}/mbuf.p\
        ${srcdir}/misc.p ${srcdir}/options.p ${srcdir}/ppp.p ${srcdir}/sbuf.p\
	${srcdir}/sl.p ${srcdir}/slcompress.p ${srcdir}/socket.p ${srcdir}/tcp_input.p\
	${srcdir}/tcp_output.p ${srcdir}/tcp_subr.p ${srcdir}/tcp_timer.p\
	${srcdir}/terminal.p ${srcdir}/ttys.p ${srcdir}/udp.p

LIBS = -lcrypt -lnsl 

COMMON_H = config.h ${srcdir}/slirp.h

BINDIR = /usr/local/bin

MANDIR = /usr/local/man/man1

MANEXT = 1

all: ${srcdir}/configure Makefile config.h slirp

slirp: $(PROTO) $(OBJ)
	$(CC)  -o slirp $(OBJ) $(LIBS)

install: slirp install.man
	strip slirp
	cp slirp $(BINDIR)

install.man:
	cp slirp.man $(MANDIR)/slirp.$(MANEXT)

objclean:
	rm -f $(OBJ)

confclean:
	rm -f config.h config.log config.status\
		config.cache Makefile

proclean:
	rm -f *.p

realclean: objclean confclean
	rm -f slirp core slirp.core core.slirp
	rm -f *~

clean: objclean
	rm -f slirp core slirp.core core.slirp

${srcdir}/configure: ${srcdir}/configure.in
	cd ${srcdir} && autoconf || touch ${srcdir}/configure

Makefile: ${srcdir}/Makefile.in config.status
	./config.status

# RUN_MAKE_AGAIN

config.status: ${srcdir}/configure
	./config.status --recheck

# This just helps me, you can ignore it
release: all
	rm -f $(OBJ)
	rm -f config.h config.log config.status \
		config.cache Makefile
	rm -f slirp core slirp.core core.slirp
	rm -f ${srcdir}/*~ ${srcdir}/ppp/*~
	(cd ${srcdir}/../..; \
	 tar cvzf slirp-${version}.tar.gz slirp-${version};)
	cp -u ${srcdir}/../ChangeLog ${srcdir}/../../slirp.ChangeLog 
	cp -u ${srcdir}/../slirp-${version}.lsm ${srcdir}/../.. 

#
# Prototypes and .o files
#

.c.p:
	$(MAKEPRO)


auth.o: $(COMMON_H) ${srcdir}/ppp/auth.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/auth.c

bsd-comp.o: $(COMMON_H) ${srcdir}/ppp/bsd-comp.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/bsd-comp.c

ccp.o: $(COMMON_H) ${srcdir}/ppp/ccp.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/ccp.c

chap.o: $(COMMON_H) ${srcdir}/ppp/chap.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/chap.c

fsm.o: $(COMMON_H) ${srcdir}/ppp/fsm.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/fsm.c

ipcp.o: $(COMMON_H) ${srcdir}/ppp/ipcp.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/ipcp.c

lcp.o: $(COMMON_H) ${srcdir}/ppp/lcp.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/lcp.c

magic.o: $(COMMON_H) ${srcdir}/ppp/magic.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/magic.c

md5.o: $(COMMON_H) ${srcdir}/ppp/md5.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/md5.c

pppdfncs.o: $(COMMON_H) ${srcdir}/ppp/pppdfncs.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/pppdfncs.c

upap.o: $(COMMON_H) ${srcdir}/ppp/upap.c
	$(CC) $(PPPCFLAGS) -c ${srcdir}/ppp/upap.c


cksum.o: $(COMMON_H) ${srcdir}/cksum.c
	$(CC) $(CFLAGS) -c ${srcdir}/cksum.c

debug.o: $(COMMON_H) ${srcdir}/debug.c
	$(CC) $(CFLAGS) -c ${srcdir}/debug.c

if.o: $(COMMON_H) ${srcdir}/if.c
	$(CC) $(CFLAGS) -c ${srcdir}/if.c

ip_icmp.o: ${srcdir}/ip_icmp.c $(COMMON_H) ${srcdir}/ip.h 
	$(CC) $(CFLAGS) -c -o $@ $<

ip_input.o: ${srcdir}/ip_input.c $(COMMON_H) ${srcdir}/ip.h 
	$(CC) $(CFLAGS) -c -o $@ $<

ip_output.o: ${srcdir}/ip_output.c $(COMMON_H) ${srcdir}/ip.h
	$(CC) $(CFLAGS) -c -o $@ $<

main.o: $(COMMON_H) ${srcdir}/main.c
	$(CC) $(CFLAGS) -c ${srcdir}/main.c

mbuf.o: $(COMMON_H) ${srcdir}/mbuf.c
	$(CC) $(CFLAGS) -c ${srcdir}/mbuf.c

misc.o: $(COMMON_H) ${srcdir}/misc.c
	$(CC) $(CFLAGS) -c ${srcdir}/misc.c

options.o: $(COMMON_H) ${srcdir}/options.c
	$(CC) $(CFLAGS) -c ${srcdir}/options.c

ppp.o: $(COMMON_H) ${srcdir}/ppp.c
	$(CC) $(CFLAGS) -c ${srcdir}/ppp.c

sbuf.o: $(COMMON_H) ${srcdir}/sbuf.c
	$(CC) $(CFLAGS) -c ${srcdir}/sbuf.c

sl.o: $(COMMON_H) ${srcdir}/sl.c
	$(CC) $(CFLAGS) -c ${srcdir}/sl.c

slcompress.o: $(COMMON_H) ${srcdir}/slcompress.c
	$(CC) $(CFLAGS) -c ${srcdir}/slcompress.c

socket.o: $(COMMON_H) ${srcdir}/socket.c
	$(CC) $(CFLAGS) -c ${srcdir}/socket.c

tcp_input.o: $(COMMON_H) ${srcdir}/tcp_input.c
	$(CC) $(CFLAGS) -c ${srcdir}/tcp_input.c

tcp_output.o: $(COMMON_H) ${srcdir}/tcp_output.c
	$(CC) $(CFLAGS) -c ${srcdir}/tcp_output.c

tcp_subr.o: $(COMMON_H) ${srcdir}/tcp_subr.c
	$(CC) $(CFLAGS) -c ${srcdir}/tcp_subr.c

tcp_timer.o: $(COMMON_H) ${srcdir}/tcp_timer.c
	$(CC) $(CFLAGS) -c ${srcdir}/tcp_timer.c

terminal.o: $(COMMON_H) ${srcdir}/terminal.c
	$(CC) $(CFLAGS) -c ${srcdir}/terminal.c

ttys.o: $(COMMON_H) ${srcdir}/ttys.c
	$(CC) $(CFLAGS) -c ${srcdir}/ttys.c

udp.o: $(COMMON_H) ${srcdir}/udp.c
	$(CC) $(CFLAGS) -c ${srcdir}/udp.c

memcmp.o: ${srcdir}/memcmp.c
	$(CC) $(CFLAGS) -c ${srcdir}/memcmp.c

strtoul.o: ${srcdir}/strtoul.c
	$(CC) $(CFLAGS) -c ${srcdir}/strtoul.c


.c.o: $(COMMON_H)
	$(CC) $(CFLAGS) -c $< -o $@

## slirp 1.0.17

=== debian/changelog ===
slirp (1:1.0.17-12) unstable; urgency=low

  * New starndards. dep5-copyright file.
  * Add libcrypt-dev to Build-Depends (Closes: #1107023).
  * Fix immediate exit at startup and debug fixes (Closes: #1043201).
  * Convert CDBS build to debhelper. (Closes: #1115159).
  * Fix FTBFS with make --shuffle=reverse (Closes: #1105592).
  * Fix compiler warnings.

 -- Roberto Lumbreras <rover@debian.org>  Sat, 15 Nov 2025 00:37:02 +0100

slirp (1:1.0.17-11) unstable; urgency=high

  * add 015_949003_explicit_extern_declaration.patch
    (Closes: #957812)
    Thanks to Bernhard Übelacker for providing the patch!
  * add 016_c11b4078042_fix_64_bit_issue_in_slirp.patch
    (Closes: #949003)
    Thanks to Bernhard Übelacker for providing the patch!
  * CVE-2020-8608 (017_CVE-2020-8608.patch)
    Prevent a buffer overflow vulnerability due to incorrect usage
    of return values from snprintf.
  * debian/control: bump standard to 4.5.1 (no changes)
  * debian/control: add myself to Uploaders:

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 13 Jul 2020 19:03:02 +0100

slirp (1:1.0.17-10) unstable; urgency=high

  * Fix for CVE-2020-7039 (Closes: #949085)
  * Make it compile on GNU Hurd, really.

 -- Roberto Lumbreras <rover@debian.org>  Fri, 24 Jan 2020 20:12:54 +0100

slirp (1:1.0.17-9) unstable; urgency=medium

  * Fix crash after startup bug (Closes: #948268)
  * Make it compile on GNU Hurd.
  * Updated standards and minor fixes.

 -- Roberto Lumbreras <rover@debian.org>  Wed, 15 Jan 2020 00:54:06 +0100

slirp (1:1.0.17-8) unstable; urgency=low

  * Fix FTBFS with GCC 5.0 (Closes: #778124)
  * Updated standards.

 -- Roberto Lumbreras <rover@debian.org>  Thu, 25 Jun 2015 17:03:40 +0200

slirp (1:1.0.17-7) unstable; urgency=low

  * Fix IPCP negotiation fails for 64-bit hosts (Closes: #685056)
  * Set debhelper compat to 9.

 -- Roberto Lumbreras <rover@debian.org>  Thu, 16 Aug 2012 11:19:57 +0200

slirp (1:1.0.17-6) unstable; urgency=low

  * Apply ``real full bolt'' patch. (Closes: #658359)
  * Updated standards.

 -- Roberto Lumbreras <rover@debian.org>  Mon, 05 Mar 2012 19:38:33 +0100

slirp (1:1.0.17-5) unstable; urgency=low

  * Don't delete *.p files and don't run 'mkpro' perl script anymore to
    automatically regenerate prototypes, as it stopped working somehow,
    resulting in FTBFS. (Closes: #628280)
  * Updated standards.
  * Add -Wl,--as-needed to LDFLAGS.

 -- Roberto Lumbreras <rover@debian.org>  Mon, 06 Jun 2011 06:18:08 +0200

slirp (1:1.0.17-4) unstable; urgency=low

  * Fix crash on amd64 when enabling file logging. (Closes: #587907)
  * Updated standards.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Fix watch file.

 -- Roberto Lumbreras <rover@debian.org>  Sun, 04 Jul 2010 21:16:28 +0200

slirp (1:1.0.17-3) unstable; urgency=low

  * Updated standards.
  * Fix arguements spelling-error-in-binary (lintian).
  * debian/HOWTO-TEST: use "ssh -t" to force tty allocation. (Closes: #544124)

 -- Roberto Lumbreras <rover@debian.org>  Sat, 29 Aug 2009 14:17:24 +0200

slirp (1:1.0.17-2) unstable; urgency=low

  * Clean up compilation warnings and a few snprintf changes.
    Use addrlen as socklen_t instead of int. Tested on amd64 and it works.
    (Closes: #29245)
  * Switch to cdbs.

 -- Roberto Lumbreras <rover@debian.org>  Tue, 14 Aug 2007 17:22:55 +0200

slirp (1:1.0.17-1) unstable; urgency=low

  * New upstream version. (Closes: #175079)
  * Add slirp-fullbolt manpage. (Closes: #223920)
  * Updated standards (no changes).

 -- Roberto Lumbreras <rover@debian.org>  Thu, 18 May 2006 19:42:29 +0200

slirp (1:1.0.16-3) unstable; urgency=high

  * Add an epoch to fix hijacking of package by Debian JED group.
    (Closes: #339578)
  * Updated standards (no changes).

 -- Roberto Lumbreras <rover@debian.org>  Mon, 16 Jan 2006 14:10:48 +0100

slirp (1.0.16-2) unstable; urgency=high

  * Fix ttyname segfault. Added -fno-strict-aliasing to CFLAGS to avoid
  incorrect code generation with gcc >= 3.3. (closes:#295832)

 -- Roberto Lumbreras <rover@debian.org>  Tue, 01 Mar 2005 12:15:03 +0100

slirp (1.0.16-1) unstable; urgency=low

  * New upstream version.
  * Updated standards.

 -- Roberto Lumbreras <rover@debian.org>  Fri, 04 Feb 2005 03:53:09 +0100

slirp (1.0.14pre1-4) unstable; urgency=low

  * Provide a separate slirp-fullbolt binary built with FULL_BOLT.
    (closes:#175093)

 -- Roberto Lumbreras <rover@debian.org>  Tue, 06 May 2003 17:17:40 +0200

slirp (1.0.14pre1-3) unstable; urgency=low

  * src/debug.c: added ifndef so it compiles with FULL_BOLT. (closes:#175083)
  * Standards 3.5.9.

 -- Roberto Lumbreras <rover@debian.org>  Sat, 15 Mar 2003 19:37:13 +0100

slirp (1.0.14pre1-2) unstable; urgency=low

  * debian/rules: switched to debhelper.
  * debian/control: added slirp home page to description.

 -- Roberto Lumbreras <rover@debian.org>  Fri, 12 Jul 2002 18:32:34 +0200

slirp (1.0.14pre1-1) unstable; urgency=low

  * New upstream version.
  * Standards 3.5.2.

 -- Roberto Lumbreras <rover@debian.org>  Sun,  1 Apr 2001 19:57:28 +0200

slirp (1.0.9-1) unstable; urgency=low

  * New upstream version.
  * Standards 3.1.1.

 -- Roberto Lumbreras <rover@debian.org>  Sun, 26 Mar 2000 20:53:27 +0200

slirp (1.0g-2) frozen; urgency=high

  * Fixed important bug. (closes: bug#59608)

 -- Roberto Lumbreras <rover@debian.org>  Sat, 25 Mar 2000 20:34:48 +0100

slirp (1.0g-1) unstable; urgency=low

  * New upstream version.

 -- Roberto Lumbreras <rover@debian.org>  Wed, 18 Aug 1999 13:16:06 +0200

slirp (1.0f-1) unstable; urgency=low

  * New upstream version.

 -- Roberto Lumbreras <rover@debian.org>  Wed, 17 Mar 1999 19:02:28 +0100

slirp (1.0d-1) unstable; urgency=low

  * New upstream version.

 -- Roberto Lumbreras <rover@debian.org>  Sun, 11 Oct 1998 01:49:06 +0200

slirp (1.0c-1) unstable; urgency=low

  * initial release
  * added debian files

 -- Roberto Lumbreras <rover@debian.org>  Mon,  3 Aug 1998 01:03:35 +0200

=== debian/control ===
Source: slirp
Section: net
Priority: optional
Maintainer: Roberto Lumbreras <rover@debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (=13), libcrypt-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://slirp.sourceforge.net

Package: slirp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SLIP/PPP emulator using a dial up shell account
 Slirp is a TCP/IP emulator which turns an ordinary shell account
 into a (C)SLIP/PPP account.  This allows shell users to use all the
 funky Internet applications like Netscape, Mosaic, CUSeeMe, etc.
 .
 Please note that maybe your ISP really doesn't like you using slirp,
 because they want to charge more for a ppp connection, so use it at
 your own risk.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall

#CC        = gcc
CFLAGS   += $(CPPFLAGS) -I. -DUSE_PPP -DUSE_MS_DNS -fno-strict-aliasing -Wno-unused -std=gnu89
PPPCFLAGS = $(CFLAGS)
LDFLAGS += -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	cd src && ./configure --prefix=/usr

override_dh_auto_clean:
	[ ! -f src/Makefile ] || $(MAKE) -C src realclean
	rm -f src/slirp-fullbolt

override_dh_auto_build:
	# build FULLBOLT
	$(MAKE) -C src clean && $(MAKE) -C src \
		CFLAGS="$(CFLAGS) -DFULL_BOLT" \
		PPPCFLAGS="$(PPPCFLAGS)" all && \
		mv src/slirp src/slirp-fullbolt
	# build NORMAL
	$(MAKE) -C src clean && $(MAKE) -C src \
		CFLAGS="$(CFLAGS)" \
		PPPCFLAGS="$(PPPCFLAGS)" all

=== debian/watch ===
version=4
opts=uversionmangle=s/_patch//;s/_/./g http://sf.net/slirp/slirp-?_?([\w+\d+\.]+|\d+)(?:\.tar|\.tgz)(?:\.gz|\.bz2|)

## slirp 1.0.17.1

=== debian/changelog ===
slirp (1:1.0.17.1-1+security) unstable; urgency=medium

  * update

 -- Roberto Lumbreras <rover@debian.org>  Fri, 16 Apr 2021 14:49:10 +0800

slirp (1:1.0.17.1-1+security) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-7039 CVE-2020-8608

 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 16 Apr 2021 14:24:39 +0800

slirp (1:1.0.17-8+deb10u1) buster; urgency=high

  * CVE-2020-7039
    Due to mismanagement of memory, a heap-based buffer overflow or
    other out-of-bounds access might happen, which can lead to a DoS
    or potential execute arbitrary code.
  * CVE-2020-8608
    Prevent a buffer overflow vulnerability due to incorrect usage
    of return values from snprintf.

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 21 Dec 2020 20:03:02 +0100

## slirp 1.7.6.r3

=== examples/cpp/Makefile ===

CPP_DEMO	= cppdemo
MODULE_NAME	= $(CPP_DEMO)
C_DEMO		= cdemo
CPP_GLUE	= $(CPP_DEMO)_glue
C_GLUE		= $(C_DEMO)_glue
OTHER_ALL	= $(CPP_DEMO) $(C_DEMO) $(MODULE)
OTHER_CLEAN	= $(OTHER_ALL) $(TEST_SCRIPT_REF) $(CPP_GLUE).* $(C_GLUE).* \
   			$(TEST_SCRIPT).out $(C_DEMO).out $(CPP_DEMO).out

include ../Makefile.inc

CPP_HEADERS = cdecl.hh computation.hh pi.hh err.hh vec.hh
CPP_OBJS    = computation.o pi.o
MODULE_DEPS = $(CPP_GLUE).o $(CPP_OBJS)

EXAMPLE_SCRIPT = $(CPP_DEMO).sl

demo:	module_demo executable_demo

module_demo: $(SLSH) $(SLIRPSCRIPT) $(MODULE)
	@echo
	@echo Now running the example script ...
	@echo
	$(SLSH) -n $(EXAMPLE_SCRIPT)

$(MODULE): $(MODULE_DEPS)
	@echo
	$(CXX_ELF_LINK_CMD) -o $@ $(MODULE_DEPS) $(SLANGLIB) \
						$(ELF_DEP_LIBS) $(CXX_LIBS)
	@echo

$(CPP_GLUE).o: $(CPP_GLUE).cc
	@echo
	$(CXX_COMPILE) $?

$(CPP_GLUE).cc: $(CPP_HEADERS)
	@echo
	@echo Generating S-Lang wrappers for C++ code ...
	@echo
	$(SLIRP) -m $(CPP_DEMO) $(CPP_HEADERS)

$(C_GLUE).cc: $(CPP_HEADERS)
	@echo
	@echo Generating pure C wrappers for C++ code ...
	@echo
	$(SLIRP) -m $(C_DEMO) -cfront $(CPP_HEADERS)

pi.o: pi.cc pi.hh computation.hh
computation.o: computation.cc computation.hh

executable_demo: $(CPP_DEMO) $(C_DEMO)
	@echo
	./$(CPP_DEMO)
	./$(C_DEMO)

$(CPP_DEMO): cppdemo.cc $(CPP_OBJS) err.hh
	$(CXX) $(CXXFLAGS) -o $@ cppdemo.cc $(CPP_OBJS) \
					$(SLANGLIB) $(ELF_DEP_LIBS)

$(C_DEMO): $(C_DEMO).o $(C_GLUE).o $(CPP_OBJS)
	$(CXX) -o $@ $@.o $(CPP_OBJS) $(C_GLUE).o $(SLANGLIB) $(ELF_DEP_LIBS)

$(C_GLUE).o:  $(C_GLUE).cc  $(C_GLUE).h
$(C_DEMO).o: $(C_DEMO).c $(C_GLUE).cc

TEST_SCRIPT = ./test.sl
TEST_SCRIPT_REF = test.ref
DEMO_EXE_REF = exe-output.ref

test: test_cppdemo test_cdemo test_script

test_cdemo: $(C_DEMO)
	./$(C_DEMO) > $(C_DEMO).out
	diff $(DEMO_EXE_REF) $(C_DEMO).out
	@echo

test_cppdemo: $(CPP_DEMO)
	./$(CPP_DEMO) > $(CPP_DEMO).out
	diff $(DEMO_EXE_REF) $(CPP_DEMO).out
	@echo

test_script: $(MODULE) $(TEST_SCRIPT) $(EXAMPLE_SCRIPT) $(TEST_SCRIPT_REF)
	$(SLSH) $(TEST_SCRIPT) > $(TEST_SCRIPT).out 2>&1
	diff $(TEST_SCRIPT_REF) $(TEST_SCRIPT).out

$(TEST_SCRIPT_REF): slang1.ref slang2.ref
	cp slang`echo $(SLANG_VERSION) | cut -c1`.ref $@

=== examples/fortran/Makefile ===

FDEMO		= fdemo
FSUBS		= fsubs
CSUBS		= csubs
CDEMO		= cdemo
MODULE_NAME	= fsubs
OTHER_CFLAGS	= $(F2C_INCLUDE)
OTHER_ALL	= $(CDEMO) $(FDEMO)
OTHER_CLEAN	= $(TEST_OUTPUT) $(GLUE).c $(TEST_BASELINE) \
  		$(MODULE_NAME).f.h fdemo cdemo *.out

sanity:
	@if [ $(HAVE_F2C) -eq 0 ] ; then \
	   echo "The f2c translator is not installed on your system." ; \
	else \
	   $(MAKE) all ; \
	fi

include ../Makefile.inc

MODULE_DEPS = $(GLUE).o $(FSUBS).o  $(CSUBS).o

EXAMPLE_SCRIPT = example.sl

demo:	$(MODULE)
	@echo
	@echo Now running the example script ...
	@echo
	$(SLSH) -n $(EXAMPLE_SCRIPT)

$(MODULE): $(MODULE_DEPS)
	@echo
	$(ELF_LINK_CMD) -o $@ $(MODULE_DEPS) $(SLANGLIB) $(F2C_LIB)
	@echo

$(GLUE).o: $(GLUE).c
	@echo
	$(ELF_COMPILE) $(GLUE).c

$(GLUE).c: slirprc $(FSUBS).f $(CSUBS).h
	@echo
	@echo Generating mixed FORTRAN/C wrappers ...
	@echo
	$(SLIRP) $(FSUBS).f $(CSUBS).h

$(FSUBS).o: $(FSUBS).f
	@echo
	$(FORTRAN_COMPILE) $(FSUBS).f

TEST_SCRIPT = ./sldemo.sl
TEST_SCRIPT_REF = test.ref
DEMO_EXE_REF = test.ref
DEMO_INPUT = coeffs.dat

test:
	@if [ $(HAVE_F2C) -eq 0 ] ; then \
	   echo "The f2c translator is not installed on your system." 1>&2; \
	else \
	   $(MAKE) test_fdemo test_cdemo test_sldemo ; \
	fi

$(CDEMO): $(CDEMO).o $(FSUBS).o $(CSUBS).o
	$(FORTRAN_LINK) -o $@ $@.o $(FSUBS).o $(CSUBS).o

$(FDEMO): $(FSUBS).o $(FDEMO).f
	$(FORTRAN_LINK) -o $@ $@.f $(FSUBS).o

test_cdemo: $(CDEMO)
	./$(CDEMO) < $(DEMO_INPUT) > $(CDEMO).out
	diff $(DEMO_EXE_REF) $(CDEMO).out
	@echo

test_fdemo: $(FDEMO)
	./$(FDEMO) $(DEMO_INPUT) > $(FDEMO).out
	diff $(DEMO_EXE_REF) $(FDEMO).out
	@echo

test_sldemo: $(MODULE) $(TEST_SCRIPT) $(TEST_SCRIPT_REF)
	$(SLSH) -n $(TEST_SCRIPT) < $(DEMO_INPUT) > $(TEST_SCRIPT).out 2>&1
	diff $(TEST_SCRIPT_REF) $(TEST_SCRIPT).out
